<template>

  <label class="base-textarea"
         :class="{
           'success': !error && (value === 0 || value && String(value).length),
           'focused': isFocused,
           'error': error
         }">

    <textarea class="base-textarea__field"
              required
              v-model="innerValue"
              @input="onInput"

              @focus="isFocused = true"
              @blur="isFocused = false">
    </textarea>

    <span class="base-textarea__label">{{label}}</span>
  </label>

</template>

<script>
  export default {
    name: 'BaseTextarea',
    model: {
      prop: 'value',
      event: 'update'
    },
    props: {
      label: {
        type: String,
        required: true
      },

      value: {
        type: [String, Number, Date],
        default: ''
      },

      error: {
        type: Boolean,
        default: false,
      }
    },
    data: () => ({
      isFocused: false,
      innerValue: null
    }),
    mounted() {
      this.innerValue = this.value;
    },
    methods: {
      onInput(event) {
        if (event.target) {
          this.$emit('update', this.innerValue)
        } else {
          this.$emit('update', event)
        }
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .base-textarea {
    @include base-input;

    position: relative;

    display: flex;
    flex-flow: column;

    height: rem(120);
    padding: 0 rem(28);

    &.success {
      .base-textarea__field {
        position: relative;
        top: rem(30);
        height: rem(72);

        & ~ .base-textarea__label {
          top: rem(12);
          transform: none;

          font-size: rem(12);
          font-weight: 400;
          line-height: rem(16);
          color: rgba($black, .6);
        }
      }
    }

    &.error {
      .base-textarea__field ~ .base-textarea__label {
        color: rgba($red, .6);
      }
    }

    &__field {
      @include p1;

      height: 100%;
      padding: 0;

      border: none;
      background: transparent;
      resize: none;

      &:focus, &:valid {
        position: relative;
        top: rem(30);
        height: auto;

        & ~ .base-textarea__label {
          top: rem(12);
          transform: none;

          font-size: rem(12);
          font-weight: 400;
          line-height: rem(16);
          color: rgba($black, .6);
        }
      }

      &:invalid {
        box-shadow: none;
      }
    }

    &__label {
      @include p1;

      position: absolute;

      top: rem(20);
      transition: all .25s;

      width: calc(100% - 3.5rem);
      overflow: hidden;
      text-overflow: ellipsis;

      color: rgba($black, .4);
      white-space: nowrap;

      pointer-events: none;
    }
  }
</style>
